Index: kernel/generic/src/synch/irq_spinlock.c
===================================================================
--- kernel/generic/src/synch/irq_spinlock.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ kernel/generic/src/synch/irq_spinlock.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,266 @@
+/*
+ * Copyright (c) 2001-2004 Jakub Jermar
+ * Copyright (c) 2023 Jiří Zárevúcky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kernel_sync
+ * @{
+ */
+
+/**
+ * @file
+ * @brief IRQ Spinlocks.
+ */
+
+#include <arch/asm.h>
+#include <synch/spinlock.h>
+
+#include <cpu.h>
+
+#ifdef CONFIG_DEBUG_SPINLOCK
+
+#define CPU_OWNER ((CPU == NULL) ? (cpu_t *) UINTPTR_MAX : CPU)
+
+static inline bool owned_by_me(irq_spinlock_t *lock)
+{
+	return atomic_load_explicit(&lock->owner, memory_order_relaxed) == CPU_OWNER;
+}
+
+static inline bool not_owned_by_me(irq_spinlock_t *lock)
+{
+	return !owned_by_me(lock);
+}
+
+static inline void claim(irq_spinlock_t *lock)
+{
+	cpu_t *cpu = CPU_OWNER;
+	atomic_store_explicit(&lock->owner, cpu, memory_order_relaxed);
+	CURRENT->mutex_locks++;
+}
+
+static inline void unclaim(irq_spinlock_t *lock)
+{
+	CURRENT->mutex_locks--;
+	atomic_store_explicit(&lock->owner, NULL, memory_order_relaxed);
+}
+
+#else
+
+static inline bool owned_by_me(irq_spinlock_t *lock)
+{
+	return true;
+}
+
+static inline bool not_owned_by_me(irq_spinlock_t *lock)
+{
+	return true;
+}
+
+static inline void claim(irq_spinlock_t *lock)
+{
+}
+
+static inline void unclaim(irq_spinlock_t *lock)
+{
+}
+
+#endif
+
+/** Initialize interrupts-disabled spinlock
+ *
+ * @param lock IRQ spinlock to be initialized.
+ * @param name IRQ spinlock name.
+ *
+ */
+void irq_spinlock_initialize(irq_spinlock_t *lock, const char *name)
+{
+	*lock = (irq_spinlock_t) IRQ_SPINLOCK_INITIALIZER(name);
+}
+
+/** Lock interrupts-disabled spinlock
+ *
+ * Lock a spinlock which requires disabled interrupts.
+ *
+ * @param lock    IRQ spinlock to be locked.
+ * @param irq_dis If true, disables interrupts before locking the spinlock.
+ *                If false, interrupts are expected to be already disabled.
+ *
+ */
+void irq_spinlock_lock(irq_spinlock_t *lock, bool irq_dis)
+{
+	ASSERT_IRQ_SPINLOCK(not_owned_by_me(lock), lock);
+
+	if (irq_dis) {
+		ipl_t ipl = interrupts_disable();
+		spinlock_lock(&(lock->lock));
+
+		lock->guard = true;
+		lock->ipl = ipl;
+	} else {
+		ASSERT_IRQ_SPINLOCK(interrupts_disabled(), lock);
+
+		spinlock_lock(&(lock->lock));
+		ASSERT_IRQ_SPINLOCK(!lock->guard, lock);
+	}
+
+	claim(lock);
+}
+
+/** Unlock interrupts-disabled spinlock
+ *
+ * Unlock a spinlock which requires disabled interrupts.
+ *
+ * @param lock    IRQ spinlock to be unlocked.
+ * @param irq_res If true, interrupts are restored to previously
+ *                saved interrupt level.
+ *
+ */
+void irq_spinlock_unlock(irq_spinlock_t *lock, bool irq_res)
+{
+	ASSERT_IRQ_SPINLOCK(interrupts_disabled(), lock);
+	ASSERT_IRQ_SPINLOCK(owned_by_me(lock), lock);
+
+	unclaim(lock);
+
+	if (irq_res) {
+		ASSERT_IRQ_SPINLOCK(lock->guard, lock);
+
+		lock->guard = false;
+		ipl_t ipl = lock->ipl;
+
+		spinlock_unlock(&(lock->lock));
+		interrupts_restore(ipl);
+	} else {
+		ASSERT_IRQ_SPINLOCK(!lock->guard, lock);
+		spinlock_unlock(&(lock->lock));
+	}
+}
+
+/** Lock interrupts-disabled spinlock
+ *
+ * Lock an interrupts-disabled spinlock conditionally. If the
+ * spinlock is not available at the moment, signal failure.
+ * Interrupts are expected to be already disabled.
+ *
+ * @param lock IRQ spinlock to be locked conditionally.
+ *
+ * @return Zero on failure, non-zero otherwise.
+ *
+ */
+bool irq_spinlock_trylock(irq_spinlock_t *lock)
+{
+	ASSERT_IRQ_SPINLOCK(interrupts_disabled(), lock);
+	bool ret = spinlock_trylock(&(lock->lock));
+	if (ret)
+		claim(lock);
+
+	ASSERT_IRQ_SPINLOCK((!ret) || (!lock->guard), lock);
+	return ret;
+}
+
+/** Pass lock from one interrupts-disabled spinlock to another
+ *
+ * Pass lock from one IRQ spinlock to another IRQ spinlock
+ * without enabling interrupts during the process.
+ *
+ * The first IRQ spinlock is supposed to be locked.
+ *
+ * @param unlock IRQ spinlock to be unlocked.
+ * @param lock   IRQ spinlock to be locked.
+ *
+ */
+void irq_spinlock_pass(irq_spinlock_t *unlock, irq_spinlock_t *lock)
+{
+	ASSERT_IRQ_SPINLOCK(interrupts_disabled(), unlock);
+	ASSERT_IRQ_SPINLOCK(owned_by_me(unlock), unlock);
+	ASSERT_IRQ_SPINLOCK(not_owned_by_me(lock), lock);
+
+	/* Pass guard from unlock to lock */
+	bool guard = unlock->guard;
+	ipl_t ipl = unlock->ipl;
+	unlock->guard = false;
+
+	unclaim(unlock);
+
+	spinlock_unlock(&(unlock->lock));
+	spinlock_lock(&(lock->lock));
+
+	claim(lock);
+
+	ASSERT_IRQ_SPINLOCK(!lock->guard, lock);
+
+	if (guard) {
+		lock->guard = true;
+		lock->ipl = ipl;
+	}
+}
+
+/** Hand-over-hand locking of interrupts-disabled spinlocks
+ *
+ * Implement hand-over-hand locking between two interrupts-disabled
+ * spinlocks without enabling interrupts during the process.
+ *
+ * The first IRQ spinlock is supposed to be locked.
+ *
+ * @param unlock IRQ spinlock to be unlocked.
+ * @param lock   IRQ spinlock to be locked.
+ *
+ */
+void irq_spinlock_exchange(irq_spinlock_t *unlock, irq_spinlock_t *lock)
+{
+	ASSERT_IRQ_SPINLOCK(interrupts_disabled(), unlock);
+	ASSERT_IRQ_SPINLOCK(owned_by_me(unlock), unlock);
+	ASSERT_IRQ_SPINLOCK(not_owned_by_me(lock), lock);
+
+	spinlock_lock(&(lock->lock));
+	ASSERT_IRQ_SPINLOCK(!lock->guard, lock);
+
+	/* Pass guard from unlock to lock */
+	if (unlock->guard) {
+		lock->guard = true;
+		lock->ipl = unlock->ipl;
+		unlock->guard = false;
+	}
+
+	claim(lock);
+	unclaim(unlock);
+
+	spinlock_unlock(&(unlock->lock));
+}
+
+/** Find out whether the IRQ spinlock is currently locked.
+ *
+ * @param lock		IRQ spinlock.
+ * @return		True if the IRQ spinlock is locked, false otherwise.
+ */
+bool irq_spinlock_locked(irq_spinlock_t *lock)
+{
+	return owned_by_me(lock) && spinlock_locked(&lock->lock);
+}
+
+/** @}
+ */
Index: kernel/generic/src/synch/mutex.c
===================================================================
--- kernel/generic/src/synch/mutex.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/synch/mutex.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2001-2004 Jakub Jermar
+ * Copyright (c) 2023 Jiří Zárevúcky
  * All rights reserved.
  *
@@ -66,64 +67,89 @@
 bool mutex_locked(mutex_t *mtx)
 {
-	return semaphore_count_get(&mtx->sem) <= 0;
+	errno_t rc = semaphore_trydown(&mtx->sem);
+	if (rc == EOK) {
+		semaphore_up(&mtx->sem);
+	}
+	return rc != EOK;
 }
 
-#define MUTEX_DEADLOCK_THRESHOLD	100000000
+static void mutex_lock_active(mutex_t *mtx)
+{
+	assert((mtx->type == MUTEX_ACTIVE) || !THREAD);
+
+	const unsigned deadlock_treshold = 100000000;
+	unsigned int cnt = 0;
+	bool deadlock_reported = false;
+
+	while (semaphore_trydown(&mtx->sem) != EOK) {
+		if (cnt++ > deadlock_treshold) {
+			printf("cpu%u: looping on active mutex %p\n", CPU->id, mtx);
+			stack_trace();
+			cnt = 0;
+			deadlock_reported = true;
+		}
+	}
+
+	if (deadlock_reported)
+		printf("cpu%u: not deadlocked\n", CPU->id);
+}
 
 /** Acquire mutex.
  *
- * Timeout mode and non-blocking mode can be requested.
+ * This operation is uninterruptible and cannot fail.
+ */
+void mutex_lock(mutex_t *mtx)
+{
+	if (mtx->type == MUTEX_RECURSIVE && mtx->owner == THREAD) {
+		assert(THREAD);
+		mtx->nesting++;
+		return;
+	}
+
+	if (mtx->type == MUTEX_ACTIVE || !THREAD) {
+		mutex_lock_active(mtx);
+		return;
+	}
+
+	semaphore_down(&mtx->sem);
+	mtx->owner = THREAD;
+	mtx->nesting = 1;
+}
+
+/** Acquire mutex with timeout.
  *
  * @param mtx    Mutex.
  * @param usec   Timeout in microseconds.
- * @param flags  Specify mode of operation.
  *
- * For exact description of possible combinations of usec and flags, see
- * comment for waitq_sleep_timeout().
- *
- * @return See comment for waitq_sleep_timeout().
- *
+ * @return EOK if lock was successfully acquired, something else otherwise.
  */
-errno_t _mutex_lock_timeout(mutex_t *mtx, uint32_t usec, unsigned int flags)
+errno_t mutex_lock_timeout(mutex_t *mtx, uint32_t usec)
 {
-	errno_t rc;
-
-	if (mtx->type == MUTEX_PASSIVE && THREAD) {
-		rc = _semaphore_down_timeout(&mtx->sem, usec, flags);
-	} else if (mtx->type == MUTEX_RECURSIVE) {
+	if (usec != 0) {
+		assert(mtx->type != MUTEX_ACTIVE);
 		assert(THREAD);
-
-		if (mtx->owner == THREAD) {
-			mtx->nesting++;
-			return EOK;
-		} else {
-			rc = _semaphore_down_timeout(&mtx->sem, usec, flags);
-			if (rc == EOK) {
-				mtx->owner = THREAD;
-				mtx->nesting = 1;
-			}
-		}
-	} else {
-		assert((mtx->type == MUTEX_ACTIVE) || !THREAD);
-		assert(usec == SYNCH_NO_TIMEOUT);
-		assert(!(flags & SYNCH_FLAGS_INTERRUPTIBLE));
-
-		unsigned int cnt = 0;
-		bool deadlock_reported = false;
-		do {
-			if (cnt++ > MUTEX_DEADLOCK_THRESHOLD) {
-				printf("cpu%u: looping on active mutex %p\n",
-				    CPU->id, mtx);
-				stack_trace();
-				cnt = 0;
-				deadlock_reported = true;
-			}
-			rc = semaphore_trydown(&mtx->sem);
-		} while (rc != EOK && !(flags & SYNCH_FLAGS_NON_BLOCKING));
-		if (deadlock_reported)
-			printf("cpu%u: not deadlocked\n", CPU->id);
 	}
 
+	if (mtx->type == MUTEX_RECURSIVE && mtx->owner == THREAD) {
+		assert(THREAD);
+		mtx->nesting++;
+		return EOK;
+	}
+
+	errno_t rc = semaphore_down_timeout(&mtx->sem, usec);
+	if (rc == EOK) {
+		mtx->owner = THREAD;
+		mtx->nesting = 1;
+	}
 	return rc;
+}
+
+/** Attempt to acquire mutex without blocking.
+ *
+ * @return EOK if lock was successfully acquired, something else otherwise.
+ */
+errno_t mutex_trylock(mutex_t *mtx)
+{
+	return mutex_lock_timeout(mtx, 0);
 }
 
Index: kernel/generic/src/synch/semaphore.c
===================================================================
--- kernel/generic/src/synch/semaphore.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/synch/semaphore.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -52,26 +52,31 @@
 void semaphore_initialize(semaphore_t *sem, int val)
 {
-	waitq_initialize(&sem->wq);
-	waitq_count_set(&sem->wq, val);
+	waitq_initialize_with_count(&sem->wq, val);
 }
 
-/** Semaphore down
- *
- * Semaphore down.
- * Conditional mode and mode with timeout can be requested.
+errno_t semaphore_trydown(semaphore_t *sem)
+{
+	return semaphore_down_timeout(sem, 0);
+}
+
+/** Semaphore down with timeout
  *
  * @param sem   Semaphore.
  * @param usec  Timeout in microseconds.
- * @param flags Select mode of operation.
- *
- * For exact description of possible combinations of
- * usec and flags, see comment for waitq_sleep_timeout().
  *
  * @return See comment for waitq_sleep_timeout().
  *
  */
-errno_t _semaphore_down_timeout(semaphore_t *sem, uint32_t usec, unsigned int flags)
+errno_t semaphore_down_timeout(semaphore_t *sem, uint32_t usec)
 {
-	return waitq_sleep_timeout(&sem->wq, usec, flags, NULL);
+	errno_t rc = waitq_sleep_timeout(&sem->wq, usec);
+	assert(rc == EOK || rc == ETIMEOUT || rc == EAGAIN);
+	return rc;
+}
+
+void semaphore_down(semaphore_t *sem)
+{
+	errno_t rc = waitq_sleep(&sem->wq);
+	assert(rc == EOK);
 }
 
@@ -85,16 +90,5 @@
 void semaphore_up(semaphore_t *sem)
 {
-	waitq_wakeup(&sem->wq, WAKEUP_FIRST);
-}
-
-/** Get the semaphore counter value.
- *
- * @param sem		Semaphore.
- * @return		The number of threads that can down the semaphore
- * 			without blocking.
- */
-int semaphore_count_get(semaphore_t *sem)
-{
-	return waitq_count_get(&sem->wq);
+	waitq_wake_one(&sem->wq);
 }
 
Index: kernel/generic/src/synch/spinlock.c
===================================================================
--- kernel/generic/src/synch/spinlock.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/synch/spinlock.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2001-2004 Jakub Jermar
+ * Copyright (c) 2023 Jiří Zárevúcky
  * All rights reserved.
  *
@@ -36,4 +37,7 @@
  */
 
+#ifdef CONFIG_SMP
+
+#include <arch/asm.h>
 #include <synch/spinlock.h>
 #include <atomic.h>
@@ -46,6 +50,4 @@
 #include <stacktrace.h>
 #include <cpu.h>
-
-#ifdef CONFIG_SMP
 
 /** Initialize spinlock
@@ -62,22 +64,20 @@
 }
 
-#ifdef CONFIG_DEBUG_SPINLOCK
-
 /** Lock spinlock
- *
- * Lock spinlock.
- * This version has limitted ability to report
- * possible occurence of deadlock.
  *
  * @param lock Pointer to spinlock_t structure.
  *
  */
-void spinlock_lock_debug(spinlock_t *lock)
+void spinlock_lock(spinlock_t *lock)
 {
+	preemption_disable();
+
+	bool deadlock_reported = false;
 	size_t i = 0;
-	bool deadlock_reported = false;
 
-	preemption_disable();
 	while (atomic_flag_test_and_set_explicit(&lock->flag, memory_order_acquire)) {
+		cpu_spin_hint();
+
+#ifdef CONFIG_DEBUG_SPINLOCK
 		/*
 		 * We need to be careful about particular locks
@@ -111,5 +111,9 @@
 			deadlock_reported = true;
 		}
+#endif
 	}
+
+	/* Avoid compiler warning with debug disabled. */
+	(void) i;
 
 	if (deadlock_reported)
@@ -119,11 +123,11 @@
 /** Unlock spinlock
  *
- * Unlock spinlock.
- *
  * @param sl Pointer to spinlock_t structure.
  */
-void spinlock_unlock_debug(spinlock_t *lock)
+void spinlock_unlock(spinlock_t *lock)
 {
+#ifdef CONFIG_DEBUG_SPINLOCK
 	ASSERT_SPINLOCK(spinlock_locked(lock), lock);
+#endif
 
 	atomic_flag_clear_explicit(&lock->flag, memory_order_release);
@@ -131,8 +135,5 @@
 }
 
-#endif
-
-/** Lock spinlock conditionally
- *
+/**
  * Lock spinlock conditionally. If the spinlock is not available
  * at the moment, signal failure.
@@ -140,5 +141,5 @@
  * @param lock Pointer to spinlock_t structure.
  *
- * @return Zero on failure, non-zero otherwise.
+ * @return true on success.
  *
  */
@@ -146,4 +147,5 @@
 {
 	preemption_disable();
+
 	bool ret = !atomic_flag_test_and_set_explicit(&lock->flag, memory_order_acquire);
 
@@ -172,159 +174,5 @@
 }
 
-#endif
-
-/** Initialize interrupts-disabled spinlock
- *
- * @param lock IRQ spinlock to be initialized.
- * @param name IRQ spinlock name.
- *
- */
-void irq_spinlock_initialize(irq_spinlock_t *lock, const char *name)
-{
-	spinlock_initialize(&(lock->lock), name);
-	lock->guard = false;
-	lock->ipl = 0;
-}
-
-/** Lock interrupts-disabled spinlock
- *
- * Lock a spinlock which requires disabled interrupts.
- *
- * @param lock    IRQ spinlock to be locked.
- * @param irq_dis If true, disables interrupts before locking the spinlock.
- *                If false, interrupts are expected to be already disabled.
- *
- */
-void irq_spinlock_lock(irq_spinlock_t *lock, bool irq_dis)
-{
-	if (irq_dis) {
-		ipl_t ipl = interrupts_disable();
-		spinlock_lock(&(lock->lock));
-
-		lock->guard = true;
-		lock->ipl = ipl;
-	} else {
-		ASSERT_IRQ_SPINLOCK(interrupts_disabled(), lock);
-
-		spinlock_lock(&(lock->lock));
-		ASSERT_IRQ_SPINLOCK(!lock->guard, lock);
-	}
-}
-
-/** Unlock interrupts-disabled spinlock
- *
- * Unlock a spinlock which requires disabled interrupts.
- *
- * @param lock    IRQ spinlock to be unlocked.
- * @param irq_res If true, interrupts are restored to previously
- *                saved interrupt level.
- *
- */
-void irq_spinlock_unlock(irq_spinlock_t *lock, bool irq_res)
-{
-	ASSERT_IRQ_SPINLOCK(interrupts_disabled(), lock);
-
-	if (irq_res) {
-		ASSERT_IRQ_SPINLOCK(lock->guard, lock);
-
-		lock->guard = false;
-		ipl_t ipl = lock->ipl;
-
-		spinlock_unlock(&(lock->lock));
-		interrupts_restore(ipl);
-	} else {
-		ASSERT_IRQ_SPINLOCK(!lock->guard, lock);
-		spinlock_unlock(&(lock->lock));
-	}
-}
-
-/** Lock interrupts-disabled spinlock
- *
- * Lock an interrupts-disabled spinlock conditionally. If the
- * spinlock is not available at the moment, signal failure.
- * Interrupts are expected to be already disabled.
- *
- * @param lock IRQ spinlock to be locked conditionally.
- *
- * @return Zero on failure, non-zero otherwise.
- *
- */
-bool irq_spinlock_trylock(irq_spinlock_t *lock)
-{
-	ASSERT_IRQ_SPINLOCK(interrupts_disabled(), lock);
-	bool ret = spinlock_trylock(&(lock->lock));
-
-	ASSERT_IRQ_SPINLOCK((!ret) || (!lock->guard), lock);
-	return ret;
-}
-
-/** Pass lock from one interrupts-disabled spinlock to another
- *
- * Pass lock from one IRQ spinlock to another IRQ spinlock
- * without enabling interrupts during the process.
- *
- * The first IRQ spinlock is supposed to be locked.
- *
- * @param unlock IRQ spinlock to be unlocked.
- * @param lock   IRQ spinlock to be locked.
- *
- */
-void irq_spinlock_pass(irq_spinlock_t *unlock, irq_spinlock_t *lock)
-{
-	ASSERT_IRQ_SPINLOCK(interrupts_disabled(), unlock);
-
-	/* Pass guard from unlock to lock */
-	bool guard = unlock->guard;
-	ipl_t ipl = unlock->ipl;
-	unlock->guard = false;
-
-	spinlock_unlock(&(unlock->lock));
-	spinlock_lock(&(lock->lock));
-
-	ASSERT_IRQ_SPINLOCK(!lock->guard, lock);
-
-	if (guard) {
-		lock->guard = true;
-		lock->ipl = ipl;
-	}
-}
-
-/** Hand-over-hand locking of interrupts-disabled spinlocks
- *
- * Implement hand-over-hand locking between two interrupts-disabled
- * spinlocks without enabling interrupts during the process.
- *
- * The first IRQ spinlock is supposed to be locked.
- *
- * @param unlock IRQ spinlock to be unlocked.
- * @param lock   IRQ spinlock to be locked.
- *
- */
-void irq_spinlock_exchange(irq_spinlock_t *unlock, irq_spinlock_t *lock)
-{
-	ASSERT_IRQ_SPINLOCK(interrupts_disabled(), unlock);
-
-	spinlock_lock(&(lock->lock));
-	ASSERT_IRQ_SPINLOCK(!lock->guard, lock);
-
-	/* Pass guard from unlock to lock */
-	if (unlock->guard) {
-		lock->guard = true;
-		lock->ipl = unlock->ipl;
-		unlock->guard = false;
-	}
-
-	spinlock_unlock(&(unlock->lock));
-}
-
-/** Find out whether the IRQ spinlock is currently locked.
- *
- * @param lock		IRQ spinlock.
- * @return		True if the IRQ spinlock is locked, false otherwise.
- */
-bool irq_spinlock_locked(irq_spinlock_t *ilock)
-{
-	return spinlock_locked(&ilock->lock);
-}
+#endif  /* CONFIG_SMP */
 
 /** @}
Index: kernel/generic/src/synch/syswaitq.c
===================================================================
--- kernel/generic/src/synch/syswaitq.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/synch/syswaitq.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -159,6 +159,6 @@
 #endif
 
-	errno_t rc = waitq_sleep_timeout(kobj->waitq, timeout,
-	    SYNCH_FLAGS_INTERRUPTIBLE | flags, NULL);
+	errno_t rc = _waitq_sleep_timeout(kobj->waitq, timeout,
+	    SYNCH_FLAGS_INTERRUPTIBLE | flags);
 
 #ifdef CONFIG_UDEBUG
@@ -183,5 +183,5 @@
 		return (sys_errno_t) ENOENT;
 
-	waitq_wakeup(kobj->waitq, WAKEUP_FIRST);
+	waitq_wake_one(kobj->waitq);
 
 	kobject_put(kobj);
